* Program.: BPTEST.PRG
* Author..: Charles Alan Butler    
* Date....: 04/08/90
* Notice..: Copyright (c) 1990,MIS Consulting, All Rights Reserved
* Notes...: Template Button Menu Ver(2) 4/6/90 *CAB*
* Notes...: Target Language is FoxPro.
****  Debug  *****
DO set_fox
DO mis_logo
****  Debug  *****
** -- Save some of the calling environment
ButtSch1=SCHEME(1)  &&  SAVE Colors   [FoxPro]
ButtSch2=SCHEME(2)  &&  SAVE Colors   [FoxPro]
**  --  Declare private variables
PRIVATE ButRef,ButtColor,ButtScrn,cnt,ColorStr,LastColor
PRIVATE Mpt,MaxMpt,SayString,Tmp,rw,cl

DIMENSION GroupFlag(14)
**  Flag Groups as follows
**  Value of  1 to n  = Radio Button Groups
**  Value of  0 = Check Box
**  Value of -1 = Proceed Text Button
**  Value of -2 = Abort Text Button
**  Value of -3 = Menu Choice Text Button
**  Value of -4 = GET variable
**  Value of -5 = Pop Button
**  Value of -6 = Scrollable List
GroupFlag( 1)=1     &&  Button Group
GroupFlag( 2)=1     &&  Button Group
GroupFlag( 3)=1     &&  Button Group
GroupFlag( 4)=1     &&  Button Group
GroupFlag( 5)=1     &&  Button Group
GroupFlag( 6)=1     &&  Button Group
GroupFlag( 7)=-4    &&  GET variable
GroupFlag( 8)=-4    &&  GET variable
GroupFlag( 9)=0     &&  Check Box
GroupFlag(10)=0     &&  Check Box
GroupFlag(11)=-5    &&  Pop Button
GroupFlag(12)=-3    &&  Menu Item
GroupFlag(13)=-1    &&  Proceed
GroupFlag(14)=-2    &&  ESCape

**  Set true defaults, one per Radio Group
IF TYPE('T_F(14)') # 'L'  && Skip if already defined   RELEASE T_F
   PUBLIC T_F(14)
   T_F( 2)=.T.   &&  Button Group 1
   T_F( 9)=.T.   &&  Check Box
ENDIF

IF TYPE('Ky') # 'N'  && Skip if already defined
   RELEASE Ky
   PUBLIC Ky         &&  Returns the ASCII number of the exit key
ENDIF

**  --  Memory Variables
IF TYPE("MemoryData") # "C"
   PUBLIC MemoryData
  MemoryData='any text here'
ENDIF
IF TYPE("Choice2") # "C"
   PUBLIC Choice2
  Choice2='first '
ENDIF
IF TYPE("Pick1") # "C"
   PUBLIC Pick1
  Pick1='Choice 0'
ENDIF

******************************************************************************
**  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  **
**
**    Do not Add or delete characters from the folowing array as the prg
**    relies on the exact location of the button and trailing numbers
**
**  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  **
******************************************************************************
DIMENSION SayAry(14)    &&  --  Array Used to Display Choices  --
DIMENSION HotKey(14)    &&  --  Array Used to Display Hot Keys  --
SayAry( 1)='@  2, 5 SAY "( ) Printer Output       "'
HotKey( 1) = "P 2 9r+/rb"
SayAry( 2)='@  3, 5 SAY "( ) Screen Output        "'
HotKey( 2) = "S 3 9r+/rb"
SayAry( 3)='@  4, 5 SAY "( ) File Output          "'
HotKey( 3) = "F 4 9r+/rb"
SayAry( 4)='@  5, 5 SAY "( ) Incomplete Jobs      "'
HotKey( 4) = "I 5 9r+/rb"
SayAry( 5)='@  6, 5 SAY "( ) Do a prg when pressed"'
HotKey( 5) = "D 6 9r+/rb"
SayAry( 6)='@  7, 5 SAY "( ) As many as you need  "'
HotKey( 6) = "A 7 9r+/rb"
SayAry( 7)='@ 10, 5 SAY "Data Entry :" GET MemoryData PICTURE "XXXXXXXXXXXXXXX"'
HotKey( 7) = "E1010r+/rb"
SayAry( 8)='@ 13, 3 SAY "Press Space to Change :" GET Choice2 PICTURE "@M first ,second,third ,fourth"'
HotKey( 8) = "r13 4r+/rb"
SayAry( 9)='@  2,40 SAY "[ ] Balance Due   "'
HotKey( 9) = "B 244r+/rb"
SayAry(10)='@  3,40 SAY "[ ] Phone Number"'
HotKey(10) = "h 345r+/rb"
SayAry(11)='@  7,45 SAY LEFT(Pick1+" 6,44, 8,53", 8)'
SayAry(12)='@ 11,42 SAY "(Menu Button)"'
HotKey(12) = "M1143r+/rb"
SayAry(13)='@ 12,44 SAY "  OK  "'
HotKey(13) = "O1247r+/rb"
SayAry(14)='@ 13,43 SAY "< CANCEL >"'
HotKey(14) = "C1345r+/rb"
HotKeys = "PSFIDAERBH.MOC"

**  --  Color of Menu Choice  --
DIMENSION SayColor(14)
SayColor( 1)='BG+/BR'
SayColor( 2)='BG+/BR'
SayColor( 3)='BG+/BR'
SayColor( 4)='BG+/BR'
SayColor( 5)='BG+/BR'
SayColor( 6)='BG+/BR'
SayColor( 7)='G+/BR,GR+/BG'
SayColor( 8)='G+/BR,GR+/BG'
SayColor( 9)='GR+/BR'
SayColor(10)='GR+/BR'
SayColor(11)='G+/BR'
SayColor(12)='N+/BR'
SayColor(13)='GR+/BR'
SayColor(14)='GR+/BR'

* --- Paints titles & borders on the screen
SET COLOR TO W+/BR
**  --  Set Size of Display Windows  --  **
DEFINE WINDOW Button FROM 2,6 TO 17,66 none
ACTIVATE WINDOW Button 
@ 0,0,15,60 BOX "ͻȺ "
@ 0,37,15,60 BOX "ͻʺ "
@  0, 9 SAY "[ This is a test Control Panel for FoxPro ]"
@  1, 8 SAY "*- Radio Buttons -*"
@  9, 8 SAY "*- GET a variable -*"
@ 12, 9 SAY "*- @M function -*"
@  1,40 SAY "*- Check Boxes -*"
@  5,41 SAY "*- Pop Button -*"
SET COLOR TO G+/BR
@ 6,44,8,53 BOX "ķԳ "
SET COLOR TO W+/BR
@ 10,41 SAY "*- Text Button -*"
@ 15, 4 SAY "[F1=Help]"
@  0, 0 SAY CHR(254)   &&  Close window icon
**  --  Local Variables
Mpt = 1        &&  Menu Pointer
MptMax = 14    &&  Last Menu Choice
LastColor=''   &&  Last Color Set

* --- Paints Buttons, Boxes, & Gets on the screen
SET COLOR TO BG+/BR
@  2, 5 SAY "( ) Printer Output       "
@  3, 5 SAY "( ) Screen Output        "
@  4, 5 SAY "( ) File Output          "
@  5, 5 SAY "( ) Incomplete Jobs      "
@  6, 5 SAY "( ) Do a prg when pressed"
@  7, 5 SAY "( ) As many as you need  "
SET COLOR TO G+/BR,GR+/BG
@ 10, 5 SAY "Data Entry :"
SET COLOR TO G+/BR,GR+/BG
@ 13, 3 SAY "Press Space to Change :"
SET COLOR TO GR+/BR
@  2,40 SAY "[ ] Balance Due   "
@  3,40 SAY "[ ] Phone Number"
SET COLOR TO G+/BR,G+/BR
@  7,45 SAY Pick1 PICTURE "XXXXXXXX"
@  6,44, 8,53 BOX "ķԳ"
SET COLOR TO N+/BR
@ 11,42 SAY "(Menu Button)"
SET COLOR TO GR+/BR
@ 12,44 SAY "  OK  "
@ 13,43 SAY "< CANCEL >"
CLEAR GETS

cnt =1
DO WHILE cnt <= MptMax        &&  Display Menu Choices
   IF GroupFlag(cnt) < 0      &&  Re-set text button flags
      T_F(cnt) = .F.
   ENDIF
   IF GroupFlag(cnt) >= 0
      SayAry(cnt)=STUFF(SayAry(cnt),15,1,IIF(T_F(cnt),IIF(GroupFlag(cnt)=0,'X','*'),' '))
   ENDIF
   IF LastColor # SayColor(cnt) .AND. (T_F(cnt)  .OR. GroupFlag(cnt) < -3)
      SET COLOR TO &SayColor(cnt)
      LastColor = SayColor(cnt)
      &SayAry(cnt)
   ENDIF
   IF GroupFlag(cnt)=-5   &&  Pop Button
      tmp = LEFT(RIGHT(SayAry(cnt),16),11)
      @ &tmp BOX 'ķԳ'
   ENDIF
   IF SUBSTR(HotKeys,cnt,1) # '.'      &&  Display Hot Key
      ColorStr = SUBSTR(HotKey(cnt),6)
      SET COLOR TO &ColorStr
      @ VAL(SUBSTR(HotKey(cnt),2,2)),VAL(SUBSTR(HotKey(cnt),4,2)) SAY SUBSTR(HotKey(cnt),1,1)
      LastColor = ColorStr
   ENDIF
   cnt = cnt +1
ENDDO
CLEAR GETS

DO WHILE .T.
   **  ----------  Display Highlite and get key press  ------------
   SET COLOR TO w+/b
   IF GroupFlag(Mpt)=-5             &&  Pop Button Highlite
      tmp = LEFT(RIGHT(SayAry(Mpt),16),11)
      @ &tmp BOX 'ķԳ'
   ENDIF
   &SayAry(Mpt)                     &&  Display Highlite
   IF GroupFlag(Mpt) = -4
      DO WHILE .T.
         Ky = INKEY(0,'MH')         &&  Get Key Press   ******************
         DO CASE
         CASE (Ky>31.AND.Ky<127)    &&  Allow GET
            KEYBOARD CHR(Ky)
            READ
            Ky=13   &&  ENTER in case there is code attached
            EXIT
         CASE Ky=9.OR.Ky=15.OR.Ky=27.OR.Ky=23.OR.Ky=10.OR.Ky=28 ;
              .OR.Ky=1.OR.Ky=6.OR.Ky=24.OR.Ky=5.OR.Ky=151
            CLEAR GETS              &&  Navagate Key Entered
            EXIT
         ENDCASE                    &&  Ignore all other keys
      ENDDO
   ELSE
      Ky = INKEY(0,'MH')            &&  Get Key Press   ******************
   ENDIF
   SET COLOR TO &SayColor(Mpt)      &&  Restore Color
   IF GroupFlag(Mpt)=-5             &&  Pop Button
      tmp = LEFT(RIGHT(SayAry(Mpt),16),11)
      @ &tmp BOX 'ķԳ'
   ENDIF
   &SayAry(Mpt)                     &&  Turn Highlite Off
   IF SUBSTR(HotKeys,Mpt,1) # '.'   &&  Display Hot Key
      ColorStr = SUBSTR(HotKey(Mpt),6)
      SET COLOR TO &ColorStr
      @ VAL(SUBSTR(HotKey(Mpt),2,2)),VAL(SUBSTR(HotKey(Mpt),4,2)) SAY SUBSTR(HotKey(Mpt),1,1)
      LastColor = ColorStr
   ENDIF
   IF Ky = 151             &&  Mouse Click, so decode
      Ky = 13        &&  Force ENTER
      rw = MROW()    &&  Mouse Row
      cl = MCOL()    &&  Mouse Col
      DO CASE
      CASE rw = 0 .AND. cl = 0
         Ky = 27           &&  ESCape
      CASE rw = 15
         Ky = 28           &&  Help
      CASE (rw =  2 .AND. cl >=  5 .AND. cl <= 32)
         Mpt = 1
      CASE (rw =  3 .AND. cl >=  5 .AND. cl <= 32)
         Mpt = 2
      CASE (rw =  4 .AND. cl >=  5 .AND. cl <= 32)
         Mpt = 3
      CASE (rw =  5 .AND. cl >=  5 .AND. cl <= 32)
         Mpt = 4
      CASE (rw =  6 .AND. cl >=  5 .AND. cl <= 32)
         Mpt = 5
      CASE (rw =  7 .AND. cl >=  5 .AND. cl <= 32)
         Mpt = 6
      CASE (rw = 10 .AND. cl >=  5 .AND. cl <= 19) ;
         .OR. (rw = 10 .AND. cl >= 19 .AND. cl <= 34)
         Mpt = 7
      CASE (rw = 13 .AND. cl >=  3 .AND. cl <= 28) ;
         .OR. (rw = 13 .AND. cl >= 28 .AND. cl <= 36)
         Mpt = 8
      CASE (rw =  2 .AND. cl >= 40 .AND. cl <= 60)
         Mpt = 9
      CASE (rw =  3 .AND. cl >= 40 .AND. cl <= 58)
         Mpt = 10
      CASE (rw >=  6 .AND. rw <=  8 .AND. cl >= 44 .AND. cl <= 53)
         Mpt = 11
      CASE (rw = 11 .AND. cl >= 42 .AND. cl <= 57)
         Mpt = 12
      CASE (rw = 12 .AND. cl >= 44 .AND. cl <= 54)
         Mpt = 13
      CASE (rw = 13 .AND. cl >= 43 .AND. cl <= 55)
         Mpt = 14
      OTHERWISE
         LOOP
      ENDCASE
      IF Ky = 13
         KEYBOARD CHR(13)     &&  Force ENTER Key
         LOOP                 &&  This insures the proper ROW() & COL() values
      ENDIF
   ENDIF Ky = 151    &&  Mouse Click
   IF GroupFlag(Mpt) = -4
      CLEAR GETS
   ENDIF

   **  --  Test for Hot Key  --
   IF Ky > 32 .AND. Ky < 127     &&  ASCII key pressed
      IF Ky > 96
         Ky = Ky -32             &&  Convert to Upper Case
      ENDIF
      IF CHR(Ky) $ HotKeys       &&  Hot Key found
         Mpt = AT(CHR(Ky),HotKeys)
         Ky =32
      ENDIF
   ENDIF

   **  ----------------  Process KEY strokes  ---------------------
   DO CASE
   CASE Ky=5.OR.Ky=56.OR.Ky=19.OR.Ky=52            &&  [Up]  [Left]
      Mpt = IIF(Mpt=1,MptMax,Mpt-1)

   CASE Ky=24.OR.Ky=50.OR.Ky=4.OR.Ky=54            &&  [Down]  [Right]
      Mpt = IIF(Mpt=MptMax,1,Mpt+1)

   CASE Ky = 9                                     &&  Tab to next group
      cnt = Mpt
      ButRef = GroupFlag(Mpt)
      DO WHILE cnt <= MptMax
         IF GroupFlag(cnt) # ButRef
            Mpt = cnt
            EXIT
         ENDIF
         cnt = cnt +1
      ENDDO
      Mpt = IIF(cnt>MptMax,1,Mpt)

   CASE Ky = 15                                    &&  Shift Tab prev group
      cnt = Mpt
      ButRef = GroupFlag(Mpt)
      DO WHILE cnt >= 1
         IF GroupFlag(cnt) # ButRef
            Mpt = cnt
            EXIT
         ENDIF
         cnt = cnt -1
      ENDDO
      Mpt = IIF(cnt<1,MptMax,Mpt)

   CASE Ky = 27                                    &&  ESCape
      T_F(14) = .T.
         acti scre
         do MsgLine with 'w+/r',24,'This is a test call upon Escape exit.'
      EXIT     &&  --  MENU Exit to abort

   CASE Ky = 23 .OR. Ky = 10                       &&  Ctrl-End or Ctrl-Enter
      Ky = 10     &&  Force to Ctrl-Enter code
      T_F(13) = .T.
      EXIT     &&  --  MENU Exit to proceed

   CASE Ky=28.OR.Ky=72.OR.Ky=104                   &&  [F1] [Hh]  Help
      **  put up the window
      SET COLOR TO RB+/N
      DEFINE WINDOW ButHelp FROM 2,10 TO 20,68  ;
             TITLE '[ Control Panel Help ]' DOUBLE ;
             COLOR G+/N,RB+/N,RB+/N
      ACTIVATE WINDOW ButHelp
      @ ROW()+1,2 SAY 'The following keys are active while using this panel.'
      @ ROW()+1,2 SAY '--------KEY------ACTION------------------------------'
      @ ROW()+1,2 SAY '      [Enter]  Select the item highlighted.'
      @ ROW()+1,2 SAY '      [Space]  Select the item highlighted.'
      @ ROW()+1,2 SAY '[Ctrl][Enter]  Exit the menu and proceed.'
      @ ROW()+1,2 SAY '  [Ctrl][End]  Exit the menu and proceed.'
      @ ROW()+1,2 SAY '        [ESC]  Exit without selecting.'
      @ ROW()+1,2 SAY '     [Arrows]  Up/Down, move the highlighted item.'
      @ ROW()+1,2 SAY '     [Arrows]  Right/Left, move the highlighted item.'
      @ ROW()+1,2 SAY '        [Tab]  Move Highlight forward one group'
      @ ROW()+1,2 SAY ' [Shift][Tab]  Move Highlight back one group'
      @ ROW()+1,2 SAY '       [Home]  Go to the first item.'
      @ ROW()+1,2 SAY '        [End]  Go to the last item.'
      @ ROW()+1,2 SAY '         [F1]  Displays this screen.'
      @ ROW()+1,2+14 SAY '<Press Any Key To Return>'
      cnt=INKEY(0,'HM')
      RELEASE WINDOWS ButHelp
      ACTIVATE WINDOW Button

   CASE Ky = 1 .OR. Ky = 55                        &&  Home
      Mpt = 1

   CASE Ky = 6 .OR. Ky = 49                        &&  End
      Mpt = MptMax

   CASE Ky = 13 .OR. Ky = 32                       &&  ENTER or SPACE
      **  Seperate Radio Buttons and Check Boxes from other types of choices
      IF GroupFlag(Mpt) >= 0   &&  Is Button or Check Box
         **  No action if Button is ON already
         IF GroupFlag(Mpt) = 0 .OR. .NOT. T_F(Mpt)

            DO CASE      &&  Tag Action Initiated Here
            CASE Mpt=1     &&  code from FoxView Table
               hide wind Button
               acti scre
               save scre
               Do MsgLine with 'w+/b',24,'Could be any prg call.'
               rest scre
               ACTIVATE WINDOW Button
            CASE Mpt=5     &&  code from FoxView Table
               acti scre
               save scre
               do MsgLine with 'g+/n',24,'Another test call.'
               restore scre
               
               ACTIVATE WINDOW Button
            CASE Mpt=10     &&  code from FoxView Table
               acti scre
               save scre
               Do MsgLine with 'w+/b',24,"Even a check box can have code attached."
               rest scre
               ACTIVATE WINDOW Button
            ENDCASE

            **  Set True / False Flag
            T_F(Mpt) = IIF(GroupFlag(Mpt)#0,.T.,.NOT.T_F(Mpt))

            **  Set  display of button On or Off
            SayAry(Mpt)=STUFF(SayAry(Mpt),15,1,IIF(T_F(Mpt),IIF(GroupFlag(Mpt)=0,'X','*'),' '))

            **  If Button, Need to clear all buttons in this group
            IF GroupFlag(Mpt) # 0   && Ignore if Check Box
               ButRef= GroupFlag(Mpt)   &&  Button Reference
               cnt =1
               DO WHILE cnt <= MptMax
                  IF GroupFlag(cnt) = ButRef      &&  Button group match
                     IF cnt # Mpt      &&  Clear Button
                        T_F(cnt) = .F.
                        SayAry(cnt)=STUFF(SayAry(cnt),15,1,' ')
                     ENDIF
                     ColorStr = SayColor(cnt)
                     IF LastColor # ColorStr
                        SET COLOR TO &ColorStr
                        LastColor = ColorStr
                     ENDIF
                     SayString = LEFT(SayAry(cnt),15)+'"'
                     &SayString             &&  Display Menu Choice
                  ENDIF
                  cnt = cnt +1
               ENDDO
            ENDIF
         ENDIF
      ELSE              &&  EXIT or Menu Choice
         DO CASE
         CASE Mpt=7     &&  code from FoxView Table
            acti scre
            Do MsgLine with 'rb+/n',24,'Yes, code can be added to text input.'
            ACTIVATE WINDOW Button
         CASE Mpt=11     &&  code from FoxView Table
            dime ch(4)
            ch(1)='Choice 1'
            ch(2)='Choice 2'
            ch(3)='Choice 3'
            ch(4)='Choice 4'
            @ row()-2,col()-25 MENU ch,4 title 'PICK ONE'
            read menu to pk
            Pick1=IIF(pk=0,Pick1,ch(pk))
            ACTIVATE WINDOW Button
         CASE Mpt=12     &&  code from FoxView Table
            acti scre
            save scre
            Do MsgLine with 'r+/n',24,'Menu Button for a prg call if you like.'
            rest scre
            ACTIVATE WINDOW Button
         CASE GroupFlag(Mpt) = -1
            KEYBOARD CHR(10)     &&  Force Exit
         CASE GroupFlag(Mpt) = -2
            KEYBOARD CHR(27)     &&  Force Exit
         ENDCASE
      ENDIF
   ENDCASE
ENDDO    &&  ------------------ Main Loop ---------------------------

* ---Closing operations.
RELEASE WINDOW Button
SET COLOR OF SCHEME 1 TO &ButtSch1  &&  Restore Colors   [FoxPro]
SET COLOR OF SCHEME 2 TO &ButtSch2  &&  Restore Colors   [FoxPro]
RETURN
* EOF: BPTEST.PRG
