* Program.: BTEST.PRG
* Author..: Charles Alan Butler    
* Date....: 04/08/90
* Notice..: Copyright (c) 1990,MIS Consulting, All Rights Reserved
* Notes...: Template Button Menu Ver(2) 4/6/90 *CAB*
* Notes...: Target Language is FoxBase Version 2.1 .
****  Debug  *****
DO set_fox
DO mis_logo
****  Debug  *****
** -- Save some of the calling environment
SAVE SCREEN TO ButtScrn
ButtColor=SYS(2001,"COLOR")  &&  SAVE Colors     [Fox 2.1]
Null = SYS(2002)        &&  Turn the cursor off  [Fox 2.1]
**  --  Declare private variables
PRIVATE ButRef,ButtColor,ButtScrn,cnt,ColorStr,LastColor
PRIVATE Mpt,MaxMpt,SayString,Tmp,rw,cl

DIMENSION GroupFlag(14)
**  Flag Groups as follows
**  Value of  1 to n  = Radio Button Groups
**  Value of  0 = Check Box
**  Value of -1 = Proceed Text Button
**  Value of -2 = Abort Text Button
**  Value of -3 = Menu Choice Text Button
**  Value of -4 = GET variable
**  Value of -5 = Pop Button
**  Value of -6 = Scrollable List
GroupFlag( 1)=1     &&  Button Group
GroupFlag( 2)=1     &&  Button Group
GroupFlag( 3)=1     &&  Button Group
GroupFlag( 4)=1     &&  Button Group
GroupFlag( 5)=1     &&  Button Group
GroupFlag( 6)=1     &&  Button Group
GroupFlag( 7)=-4    &&  GET variable
GroupFlag( 8)=-4    &&  GET variable
GroupFlag( 9)=0     &&  Check Box
GroupFlag(10)=0     &&  Check Box
GroupFlag(11)=-5    &&  Pop Button
GroupFlag(12)=-3    &&  Menu Item
GroupFlag(13)=-1    &&  Proceed
GroupFlag(14)=-2    &&  ESCape

**  Set true defaults, one per Radio Group
IF TYPE('T_F(14)') # 'L'  && Skip if already defined   RELEASE T_F
   PUBLIC T_F(14)
   T_F( 2)=.T.   &&  Button Group 1
   T_F( 9)=.T.   &&  Check Box
ENDIF

IF TYPE('Ky') # 'N'  && Skip if already defined
   RELEASE Ky
   PUBLIC Ky         &&  Returns the ASCII number of the exit key
ENDIF

**  --  Memory Variables
IF TYPE("MemoryData") # "C"
   PUBLIC MemoryData
  MemoryData='any text here'
ENDIF
IF TYPE("Choice2") # "C"
   PUBLIC Choice2
  Choice2='first '
ENDIF
IF TYPE("Pick1") # "C"
   PUBLIC Pick1
  Pick1='Choice 0'
ENDIF

******************************************************************************
**  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  **
**
**    Do not Add or delete characters from the folowing array as the prg
**    relies on the exact location of the button and trailing numbers
**
**  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  **
******************************************************************************
DIMENSION SayAry(14)    &&  --  Array Used to Display Choices  --
DIMENSION HotKey(14)    &&  --  Array Used to Display Hot Keys  --
SayAry( 1)='@  4,11 SAY "( ) Printer Output       "'
HotKey( 1) = "P 415r+/rb"
SayAry( 2)='@  5,11 SAY "( ) Screen Output        "'
HotKey( 2) = "S 515r+/rb"
SayAry( 3)='@  6,11 SAY "( ) File Output          "'
HotKey( 3) = "F 615r+/rb"
SayAry( 4)='@  7,11 SAY "( ) Incomplete Jobs      "'
HotKey( 4) = "I 715r+/rb"
SayAry( 5)='@  8,11 SAY "( ) Do a prg when pressed"'
HotKey( 5) = "D 815r+/rb"
SayAry( 6)='@  9,11 SAY "( ) As many as you need  "'
HotKey( 6) = "A 915r+/rb"
SayAry( 7)='@ 12,11 SAY "Data Entry :" GET MemoryData PICTURE "XXXXXXXXXXXXXXX"'
HotKey( 7) = "E1216r+/rb"
SayAry( 8)='@ 15, 9 SAY "Press Space to Change :" GET Choice2 PICTURE "XXXXXXXX"'
HotKey( 8) = "r1510r+/rb"
SayAry( 9)='@  4,46 SAY "[ ] Balance Due   "'
HotKey( 9) = "B 450r+/rb"
SayAry(10)='@  5,46 SAY "[ ] Phone Number"'
HotKey(10) = "h 551r+/rb"
SayAry(11)='@  9,51 SAY LEFT(Pick1+" 8,50,10,59", 8)'
SayAry(12)='@ 13,48 SAY "(Menu Button)"'
HotKey(12) = "M1349r+/rb"
SayAry(13)='@ 14,50 SAY "  OK  "'
HotKey(13) = "O1453r+/rb"
SayAry(14)='@ 15,49 SAY "< CANCEL >"'
HotKey(14) = "C1551r+/rb"
HotKeys = "PSFIDAERBH.MOC"

**  --  Color of Menu Choice  --
DIMENSION SayColor(14)
SayColor( 1)='BG+/BR'
SayColor( 2)='BG+/BR'
SayColor( 3)='BG+/BR'
SayColor( 4)='BG+/BR'
SayColor( 5)='BG+/BR'
SayColor( 6)='BG+/BR'
SayColor( 7)='G+/BR,GR+/BG'
SayColor( 8)='G+/BR,GR+/BG'
SayColor( 9)='GR+/BR'
SayColor(10)='GR+/BR'
SayColor(11)='G+/BR'
SayColor(12)='N+/BR'
SayColor(13)='GR+/BR'
SayColor(14)='GR+/BR'

* --- Paints titles & borders on the screen
SET COLOR TO W+/BR
@ 2,6,17,66 BOX "ͻȺ "
@ 2,43,17,66 BOX "ͻʺ "
@  2,15 SAY "[ This is a test Control Panel for FoxPro ]"
@  3,14 SAY "*- Radio Buttons -*"
@ 11,14 SAY "*- GET a variable -*"
@ 14,15 SAY "*- @M function -*"
@  3,46 SAY "*- Check Boxes -*"
@  7,47 SAY "*- Pop Button -*"
SET COLOR TO G+/BR
@ 8,50,10,59 BOX "ķԳ "
SET COLOR TO W+/BR
@ 12,47 SAY "*- Text Button -*"
@ 17,10 SAY "[F1=Help]"
**  --  Local Variables
Mpt = 1        &&  Menu Pointer
MptMax = 14    &&  Last Menu Choice
LastColor=''   &&  Last Color Set

* --- Paints Buttons, Boxes, & Gets on the screen
SET COLOR TO BG+/BR
@  4,11 SAY "( ) Printer Output       "
@  5,11 SAY "( ) Screen Output        "
@  6,11 SAY "( ) File Output          "
@  7,11 SAY "( ) Incomplete Jobs      "
@  8,11 SAY "( ) Do a prg when pressed"
@  9,11 SAY "( ) As many as you need  "
SET COLOR TO G+/BR,GR+/BG
@ 12,11 SAY "Data Entry :"
SET COLOR TO G+/BR,GR+/BG
@ 15, 9 SAY "Press Space to Change :"
SET COLOR TO GR+/BR
@  4,46 SAY "[ ] Balance Due   "
@  5,46 SAY "[ ] Phone Number"
SET COLOR TO G+/BR,G+/BR
@  9,51 SAY Pick1 PICTURE "XXXXXXXX"
@  8,50,10,59 BOX "ķԳ"
SET COLOR TO N+/BR
@ 13,48 SAY "(Menu Button)"
SET COLOR TO GR+/BR
@ 14,50 SAY "  OK  "
@ 15,49 SAY "< CANCEL >"
CLEAR GETS

cnt =1
DO WHILE cnt <= MptMax        &&  Display Menu Choices
   IF GroupFlag(cnt) < 0      &&  Re-set text button flags
      T_F(cnt) = .F.
   ENDIF
   IF GroupFlag(cnt) >= 0
      SayAry(cnt)=STUFF(SayAry(cnt),15,1,IIF(T_F(cnt),IIF(GroupFlag(cnt)=0,'X','*'),' '))
   ENDIF
   IF (T_F(cnt)  .OR. GroupFlag(cnt) < -3)
      IF LastColor # SayColor(cnt)
         ColorStr = SayColor(cnt)
         SET COLOR TO &ColorStr
         LastColor = ColorStr
      ENDIF
      SayString = SayAry(cnt)
      &SayString
   ENDIF
   IF GroupFlag(cnt)=-5   &&  Pop Button
      tmp = LEFT(RIGHT(SayAry(cnt),16),11)
      @ &tmp BOX 'ķԳ'
   ENDIF
   IF SUBSTR(HotKeys,cnt,1) # '.'      &&  Display Hot Key
      IF LastColor # SUBSTR(HotKey(cnt),6)
         ColorStr = SUBSTR(HotKey(cnt),6)
         SET COLOR TO &ColorStr
         LastColor = ColorStr
      ENDIF
      @ VAL(SUBSTR(HotKey(cnt),2,2)),VAL(SUBSTR(HotKey(cnt),4,2)) SAY SUBSTR(HotKey(cnt),1,1)
   ENDIF
   cnt = cnt +1
ENDDO
CLEAR GETS

DO WHILE .T.
   **  ----------  Display Highlite and get key press  ------------
   SET COLOR TO w+/b
   IF GroupFlag(Mpt)=-5             &&  Pop Button Highlite
      tmp = LEFT(RIGHT(SayAry(Mpt),16),11)
      @ &tmp BOX 'ķԳ'
   ENDIF
   SayString = SayAry(Mpt)
   &SayString                       &&  Display Highlite
   IF GroupFlag(Mpt) = -4
      DO WHILE .T.
         Ky = INKEY(0)              &&  Get Key Press   ******************
         DO CASE
         CASE (Ky>31.AND.Ky<127)    &&  Allow GET
            Null = SYS(2002,1)      &&  Turn the cursor on       [Fox 2.1]
            KEYBOARD CHR(Ky)
            READ
            Null = SYS(2002)        &&  Turn the cursor off  [Fox 2.1]
            Ky=13   &&  ENTER in case there is code attached
            EXIT
         CASE Ky=9.OR.Ky=15.OR.Ky=27.OR.Ky=23.OR.Ky=10.OR.Ky=28 ;
              .OR.Ky=1.OR.Ky=6.OR.Ky=24.OR.Ky=5.OR.Ky=151
            CLEAR GETS              &&  Navagate Key Entered
            EXIT
         ENDCASE                    &&  Ignore all other keys
      ENDDO
   ELSE
      Ky = INKEY(0)                 &&  Get Key Press   ******************
   ENDIF
   ColorStr = SayColor(Mpt)         &&  Restore Color
   SET COLOR TO &ColorStr
   IF GroupFlag(Mpt)=-5             &&  Pop Button
      tmp = LEFT(RIGHT(SayAry(Mpt),16),11)
      @ &tmp BOX 'ķԳ'
   ENDIF
   &SayString                       &&  Turn Highlite Off
   IF SUBSTR(HotKeys,Mpt,1) # '.'   &&  Display Hot Key
      ColorStr = SUBSTR(HotKey(Mpt),6)
      SET COLOR TO &ColorStr
      @ VAL(SUBSTR(HotKey(Mpt),2,2)),VAL(SUBSTR(HotKey(Mpt),4,2)) SAY SUBSTR(HotKey(Mpt),1,1)
      LastColor = ColorStr
   ENDIF
   IF GroupFlag(Mpt) = -4
      CLEAR GETS
   ENDIF

   **  --  Test for Hot Key  --
   IF Ky > 32 .AND. Ky < 127     &&  ASCII key pressed
      IF Ky > 96
         Ky = Ky -32             &&  Convert to Upper Case
      ENDIF
      IF CHR(Ky) $ HotKeys       &&  Hot Key found
         Mpt = AT(CHR(Ky),HotKeys)
         Ky =32
      ENDIF
   ENDIF

   **  ----------------  Process KEY strokes  ---------------------
   DO CASE
   CASE Ky=5.OR.Ky=56.OR.Ky=19.OR.Ky=52            &&  [Up]  [Left]
      Mpt = IIF(Mpt=1,MptMax,Mpt-1)

   CASE Ky=24.OR.Ky=50.OR.Ky=4.OR.Ky=54            &&  [Down]  [Right]
      Mpt = IIF(Mpt=MptMax,1,Mpt+1)

   CASE Ky = 9                                     &&  Tab to next group
      cnt = Mpt
      ButRef = GroupFlag(Mpt)
      DO WHILE cnt <= MptMax
         IF GroupFlag(cnt) # ButRef
            Mpt = cnt
            EXIT
         ENDIF
         cnt = cnt +1
      ENDDO
      Mpt = IIF(cnt>MptMax,1,Mpt)

   CASE Ky = 15                                    &&  Shift Tab prev group
      cnt = Mpt
      ButRef = GroupFlag(Mpt)
      DO WHILE cnt >= 1
         IF GroupFlag(cnt) # ButRef
            Mpt = cnt
            EXIT
         ENDIF
         cnt = cnt -1
      ENDDO
      Mpt = IIF(cnt<1,MptMax,Mpt)

   CASE Ky = 27                                    &&  ESCape
      T_F(14) = .T.
         do MsgLine with 'w+/r',24,'This is a test call upon Escape exit.'
      EXIT     &&  --  MENU Exit to abort

   CASE Ky = 23 .OR. Ky = 10                       &&  Ctrl-End or Ctrl-Enter
      Ky = 10     &&  Force to Ctrl-Enter code
      T_F(13) = .T.
      EXIT     &&  --  MENU Exit to proceed

   CASE Ky=28.OR.Ky=72.OR.Ky=104                   &&  [F1] [Hh]  Help
      **  put up the window
      SET COLOR TO RB+/N
      SAVE SCREEN TO F1Screen
      @ 6,10,21,66 BOX 'ͻȺ '
      @ 6,27 SAY '[ Control Panel Help ]'
      @ ROW()+1,12 SAY 'The following keys are active while using this panel.'
      @ ROW()+1,12 SAY '--------KEY------ACTION------------------------------'
      @ ROW()+1,12 SAY '      [Enter]  Select the item highlighted.'
      @ ROW()+1,12 SAY '      [Space]  Select the item highlighted.'
      @ ROW()+1,12 SAY '[Ctrl][Enter]  Exit the menu and proceed.'
      @ ROW()+1,12 SAY '  [Ctrl][End]  Exit the menu and proceed.'
      @ ROW()+1,12 SAY '        [ESC]  Exit without selecting.'
      @ ROW()+1,12 SAY '     [Arrows]  Up/Down, move the highlighted item.'
      @ ROW()+1,12 SAY '     [Arrows]  Right/Left, move the highlighted item.'
      @ ROW()+1,12 SAY '        [Tab]  Move Highlight forward one group'
      @ ROW()+1,12 SAY ' [Shift][Tab]  Move Highlight back one group'
      @ ROW()+1,12 SAY '       [Home]  Go to the first item.'
      @ ROW()+1,12 SAY '        [End]  Go to the last item.'
      @ ROW()+1,12 SAY '         [F1]  Displays this screen.'
      @ ROW()+1,12+14 SAY '<Press Any Key To Return>'
      cnt=INKEY(0)    &&  wait for key press
      RESTORE SCREEN FROM F1Screen

   CASE Ky = 1 .OR. Ky = 55                        &&  Home
      Mpt = 1

   CASE Ky = 6 .OR. Ky = 49                        &&  End
      Mpt = MptMax

   CASE Ky = 13 .OR. Ky = 32                       &&  ENTER or SPACE
      **  Seperate Radio Buttons and Check Boxes from other types of choices
      IF GroupFlag(Mpt) >= 0   &&  Is Button or Check Box
         **  No action if Button is ON already
         IF GroupFlag(Mpt) = 0 .OR. .NOT. T_F(Mpt)

            DO CASE      &&  Tag Action Initiated Here
            CASE Mpt=1     &&  code from FoxView Table
               SAVE SCREEN TO ButScrn
               Do MsgLine with 'G+/N',24,'This would be a call to a print routine.'
               RESTORE SCREEN FROM ButScrn
            CASE Mpt=5     &&  code from FoxView Table
               SAVE SCREEN TO ButScrn
               do MsgLine with 'bg+/n',24,'This could be a call to another menu.'
               RESTORE SCREEN FROM ButScrn
            CASE Mpt=10     &&  code from FoxView Table
               SAVE SCREEN TO ButScrn
               Do MsgLine with 'W+/B',24,"All menu items can have a DO Prg atached."
               RESTORE SCREEN FROM ButScrn
            ENDCASE

            **  Set True / False Flag
            T_F(Mpt) = IIF(GroupFlag(Mpt)#0,.T.,.NOT.T_F(Mpt))

            **  Set  display of button On or Off
            SayAry(Mpt)=STUFF(SayAry(Mpt),15,1,IIF(T_F(Mpt),IIF(GroupFlag(Mpt)=0,'X','*'),' '))

            **  If Button, Need to clear all buttons in this group
            IF GroupFlag(Mpt) # 0   && Ignore if Check Box
               ButRef= GroupFlag(Mpt)   &&  Button Reference
               cnt =1
               DO WHILE cnt <= MptMax
                  IF GroupFlag(cnt) = ButRef      &&  Button group match
                     IF cnt # Mpt      &&  Clear Button
                        T_F(cnt) = .F.
                        SayAry(cnt)=STUFF(SayAry(cnt),15,1,' ')
                     ENDIF
                     ColorStr = SayColor(cnt)
                     IF LastColor # ColorStr
                        SET COLOR TO &ColorStr
                        LastColor = ColorStr
                     ENDIF
                     SayString = LEFT(SayAry(cnt),15)+'"'
                     &SayString             &&  Display Menu Choice
                  ENDIF
                  cnt = cnt +1
               ENDDO
            ENDIF
         ENDIF
      ELSE              &&  EXIT or Menu Choice
         DO CASE
         CASE Mpt=7     &&  code from FoxView Table
            SAVE SCREEN TO ButScrn
            Do MsgLine with 'GR+/N',24,'Yes, text input can have code atached.'
            RESTORE SCREEN FROM ButScrn
         CASE Mpt=11     &&  code from FoxView Table
            SAVE SCREEN TO ButScrn
            set colo to w+/b,w+/r
            dime ch(4)
            ch(1)='Choice 1'
            ch(2)='Choice 2'
            ch(3)='Choice 3'
            ch(4)='Choice 4'
            @ row()-2,col()-25 MENU ch,4 title 'PICK ONE'
            pk=1
            read menu to pk
            Pick1=IIF(pk=0,Pick1,ch(pk))
            rele ch
            RESTORE SCREEN FROM ButScrn
         CASE Mpt=12     &&  code from FoxView Table
            SAVE SCREEN TO ButScrn
            Do MsgLine with 'G+/N',24,'Menu Button for a prg call if you like.'
            RESTORE SCREEN FROM ButScrn
         CASE GroupFlag(Mpt) = -1
            KEYBOARD CHR(10)     &&  Force Exit
         CASE GroupFlag(Mpt) = -2
            KEYBOARD CHR(27)     &&  Force Exit
         ENDCASE
      ENDIF
   ENDCASE
ENDDO    &&  ------------------ Main Loop ---------------------------

* ---Closing operations.
SET COLOR TO &ButtColor
RESTORE SCREEN FROM ButtScrn
Null = SYS(2002,1)        &&  Turn the cursor on       [Fox 2.1]
RETURN
* EOF: BTEST.PRG
